//---------------------------------------------------------
// Tv      : WP̔
// File Name : rockpaperscissors.cpp
// Library   : OpenCV for MS-Windows 1.0
//---------------------------------------------------------

#include "rockpaperscissors.h"
#include <stdio.h>

char windowNameCapture[] = "Capture"; 		//	Lv`摜\EBhE̖O
char windowNameSkin[] = "Skin";			//	Fo摜\EBhE̖O
char windowNameConvexHull[] = "ConvexHull";	//	ConnvexHull摜\EBhE̖O
char windowNameTrack[] = "Track";		//	gbNo[̕\
IplImage *frameImage=0;
IplImage* img;

//	摜𐶐
IplImage *hsvImage;		//	HSV摜pIplImage
IplImage *convexHullImage;	//	ConvexHull摜pIplImage
IplImage *skinImage;		//	Fo摜pIplImage
IplImage *temp;			//	ꎞۑpIplImage
IplImage *label;		//	xʕۑpIplImage
char filename[1000];
char *path="C:\\Documents and Settings\\Administrator\\My Documents\\My Pictures\\frame";
int count=1;
int hmax,hmin,smax,smin,vmax,vmin;
//
//@EBhE쐬
//
void createWindows() {
	cvNamedWindow( windowNameCapture );
	cvNamedWindow( windowNameSkin );
	cvNamedWindow( windowNameConvexHull );
	cvNamedWindow( windowNameTrack );
}

//
//	F𒊏o
//
//	:
//		frameImage : Lv`摜pIplImage
//		hsvImage   : HSV摜pIplImage
//		skinImage  : Fo摜pIplImage
//
void extractSkinColor( IplImage *frameImage, IplImage *hsvImage, IplImage *skinImage ) {
	CvScalar color;		//	HSV\Fnŕ\F
	unsigned char h;	//	H
	unsigned char s;	//	S
	unsigned char v;	//	V
	
	//	BGRHSVɕϊ
	cvCvtColor( frameImage, hsvImage, CV_BGR2HSV );

	//Fo
	for( int x = 0; x < skinImage->width; x++ ) {
		for( int y = 0 ; y < skinImage->height; y++ ) {

			color = cvGet2D( hsvImage, y, x );
			h = color.val[0];
			s = color.val[1];
			v = color.val[2];

			if( h <= hmax && h >= hmin &&
				s <= smax && s >= smin &&
					v <= vmax && v >= vmin ) {
				//	F̏ꍇ
				cvSetReal2D( skinImage, y, x, 255 );
			} else {
				cvSetReal2D( skinImage, y, x, 0 );
			}
		}
	}
}

//
//	̈Ԃ
//
//	:
//		skinImage : Fo摜pIplImage
//		temp      : ꎞۑpIplImage
//
void interpolate( IplImage *skinImage, IplImage *temp ) {
	//cITERATIONSs
	cvDilate( skinImage, temp, NULL, ITERATIONS );

	//kITERATIONSs
	cvErode( temp, skinImage, NULL, ITERATIONS );
}

//
//	ő̈(̈)̒os
//
//	:
//		
//skinImage       : Fo摜pIplImage
//		label           : xO
//		convexHullImage : ConvexHull摜pIplImage
//
//	߂l:
//		̖̈ʐ
//
int pickupMaxArea(IplImage *skinImage, IplImage *label, IplImage *convexHullImage ) {

	int handarea = 0;	//	̖̈ʐ

	for(int x = 0; x < skinImage->width; x++ ) {
		for( int y=skinImage->height-1; y >= 0; y-- ) {
			if( cvGetReal2D( label, y, x ) == 1 ) {
				//	ő̈悾ꍇ
				handarea++;
				cvSet2D( convexHullImage, y, x, CV_RGB( 255, 255, 255 ) );
			} else {
				cvSetReal2D( skinImage, y, x, 0 );
				cvSet2D( convexHullImage, y, x, CV_RGB( 0, 0, 0 ) );
			}
		}
	}
	return handarea;
}

//
//	ConvexHull𐶐
//
//	:
//		skinImage   : Fo摜pIplImage
//		handarea    : ̖̈ʐ(_̐)
//		handpoint   : ̈̓_̍Wzւ̃|C^
//		hull        : ConvexHull̒_handpointɂindexԍւ̃|C^
//		pointMatrix : ̈psւ̃|C^
//		hullMatrix  : ConvexHullpsւ̃|C^
//
void createConvexHull(IplImage *skinImage, int handarea, CvPoint **handpoint, int **hull,
					  CvMat *pointMatrix, CvMat *hullMatrix ) {
	int i=0;

	//	ConvexHullvZ邽߂ɕKvȍs𐶐
	*handpoint=( CvPoint * )malloc( sizeof( CvPoint ) * handarea );
	*hull = ( int * )malloc( sizeof( int ) * handarea );
	*pointMatrix = cvMat( 1, handarea, CV_32SC2, *handpoint );
	*hullMatrix = cvMat( 1, handarea, CV_32SC1, *hull );

	for( int x = 0; x < skinImage->width; x++ ) {
		for(  int y = 0; y < skinImage->height; y++ ) {
			if( cvGetReal2D( skinImage, y, x ) == 255 ) {
				( *handpoint )[i].x = x;
				( *handpoint )[i].y = y;
				i++;
			}
		}
	}

	//	ConvexHull𐶐
	cvConvexHull2( pointMatrix, hullMatrix, CV_CLOCKWISE, 0 );
}

//
//	ConvexHull`悷
//
//	:
//		convexHullImage : ConvexHull摜pIplImage
//		handpoint       : ̈̓_̍Wz
//		hull            : ConvexHull̒_handpointɂindexԍ
//		hullcount       : ConvexHull̒_̐
//
void drawConvexHull(IplImage *convexHullImage, CvPoint *handpoint, int *hull, int hullcount ) {
	CvPoint pt0 = handpoint[hull[hullcount-1]];
	for( int i = 0; i < hullcount; i++ ) {
		CvPoint pt = handpoint[hull[i]];
		cvLine( convexHullImage, pt0, pt, CV_RGB( 0, 255, 0 ) );
		pt0 = pt;
	}
}

//
//	ConvexHull̖ʐς߂
//
//	:
//		convexHullImage : ConvexHull摜pIplImage
//		handpoint       : ̈̓_̍Wz
//		hull            : ConvexHull̒_handpointɂindexԍ
//		hullcount       : ConvexHull̒_̐@@
//
//	߂l:
//		ConvexHull̖ʐ
//
int calcConvexHullArea( IplImage *convexHullImage, CvPoint *handpoint, int *hull, int hullcount ) {

	//	ConvexHull̒_Ȃs𐶐
	CvPoint *hullpoint = ( CvPoint * )malloc( sizeof( CvPoint ) * hullcount );
	CvMat hMatrix = cvMat( 1, hullcount, CV_32SC2, hullpoint );
	for( int i = 0; i < hullcount; i++ ) {
		hullpoint[i]=handpoint[hull[i]];
	}

	//	ConvexHull̓_̐𐔂
	int hullarea = 0;
	for( int x = 0; x < convexHullImage->width; x++ ) {
		for( int y = 0;y < convexHullImage->height; y++ ) {
			if( cvPointPolygonTest( &hMatrix, cvPoint2D32f( x, y ), 0 ) > 0) {
				hullarea++;
				if(count==1)cvCircle(frameImage,cvPoint(x,y),1,cvScalar(0,0,0),-1);
			}
		}
	}
	//count=0;

	free( hullpoint );
	return hullarea;
}

//
//	WP̔s
//
//	:
//		handarea : ̖̈ʐ
//		hullarea : ConvexHull̖ʐ
//
void decide( int handarea, int hullarea ) {
	double ratio;	//	ConvexHull̖ʐςɑ΂̖̈ʐς̊
	
	ratio=handarea / ( double )hullarea;	
	printf( "Ratio = %lf\n", ratio );

	if( ratio >= ROCKMIN && ratio <= ROCKMAX ) {
		printf( "O[\n" );
	} else if( ratio >= SCISSORMIN && ratio <= SCISSORMAX ) {
		printf( "`L\n" );
	} else if( ratio >= PAPERMIN && ratio <= PAPERMAX ) {
		printf( "p[\n" );
	}
}
void Track(void){
	//	F𒊏o
	extractSkinColor( frameImage, hsvImage, skinImage );

	//	̈Ԃ
	interpolate( skinImage, temp );
		
	//	xOs
	Label *labeling = createLabeling();
	exec( labeling, skinImage, label, true, IGNORE_SIZE );

	if( getNumOfResultRegions( labeling ) > 0 ) {
		//	IGNORE_SIZE傫ȗ̈悪ꍇ

		int handarea;		//	̖̈ʐ
		int hullarea;		//	ConvexHull̖ʐ
		int hullcount;		//	ConvexHull̒_̐
		CvPoint *handpoint;	//	̈̓_̍Wz
		int *hull;		//	ConvexHull̒_handpointɂindexԍ
		CvMat pointMatrix;	//	̈ps
		CvMat hullMatrix;	//	ConvexHullps

		//	ő̈(̈)̒os
		handarea = pickupMaxArea( skinImage, label, convexHullImage );

		//	ConvexHull𐶐
		createConvexHull( skinImage, handarea, &handpoint, &hull, &pointMatrix, &hullMatrix );
			
		hullcount = hullMatrix.cols;

		//	ConvexHull`悷
		drawConvexHull( convexHullImage, handpoint, hull, hullcount );

		//	ConvexHull̖ʐς߂
		hullarea = calcConvexHullArea( convexHullImage, handpoint,hull, hullcount );

		//	WP̔s
		decide( handarea, hullarea );

		//	
		free( handpoint );
		free( hull );
	} else {
		//	摜
		cvSetZero( convexHullImage );
	}

	releaseLabeling( labeling );

	if ( skinImage->origin == 0 ) {
		//@オ_̏ꍇ
		cvFlip( skinImage, skinImage, 0 );
	}
	if ( convexHullImage->origin == 0 ) {
		//@オ_̏ꍇ
		cvFlip( convexHullImage, convexHullImage, 0 );
	}
}
void on_change(int pos){
	Track();
}
int main( int argc, char **argv ) {
	int key;					//	L[͗p̕ϐ
	CvCapture *capture = NULL;	//	JLv`p̍\

	//	J
	if( ( capture = cvCreateCameraCapture( -1 ) ) == NULL ) {
		//	JȂꍇ
		printf( "J܂\n" );
		return -1;
	}
	
	frameImage = cvQueryFrame( capture );	//	Lv`摜pIplImage

	hsvImage = cvCreateImage( cvGetSize( frameImage ),IPL_DEPTH_8U,3);
	convexHullImage = cvCreateImage( cvGetSize( frameImage ),IPL_DEPTH_8U,3 );
	skinImage = cvCreateImage( cvGetSize( frameImage ),IPL_DEPTH_8U,1);
	temp = cvCreateImage( cvGetSize( frameImage ),IPL_DEPTH_8U,1);
	label = cvCreateImage( cvGetSize( frameImage ),IPL_DEPTH_16S,1);

	//	EBhE𐶐
	createWindows();

	//	gbNo[𐶐
	cvCreateTrackbar("HMAX","Track",&hmax,255,on_change);
	cvSetTrackbarPos("HMAX","Track", 20);
	cvCreateTrackbar("HMIN","Track",&hmin,255,on_change);
	cvSetTrackbarPos("HMIN","Track", 0);
	cvCreateTrackbar("SMAX","Track",&smax,255,on_change);
	cvSetTrackbarPos("SMAX","Track", 255);
	cvCreateTrackbar("SMIN","Track",&smin,255,on_change);
	cvSetTrackbarPos("SMIN","Track", 51);
	cvCreateTrackbar("VMAX","Track",&vmax,255,on_change);
	cvSetTrackbarPos("VMAX","Track", 255);
	cvCreateTrackbar("VMIN","Track",&vmin,255,on_change);
	cvSetTrackbarPos("VMIN","Track", 0);

	while( 1 ){
		on_change(hmax);
		frameImage = cvQueryFrame( capture );
		//	摜\
		cvShowImage( windowNameCapture, frameImage );
		cvShowImage( windowNameSkin, skinImage );
		cvShowImage( windowNameConvexHull, convexHullImage );

		//	L[͔
		key = cvWaitKey( 1 );
		if( key == 'q' ) {
			//	'q'L[ꂽ烋[v𔲂
			break;
		}
		else if(key=='c'){
//printf("77\n");
sprintf(filename,"%s%d.bmp",path,count);
//printf("%s",filename);
//cvSaveImage("c:\\output.bmp",skinImage);
cvSaveImage(filename,skinImage);
//printf("77\n");
count++;
	}
	}
	
	//	Lv`
	cvReleaseCapture( &capture );
	//	
	cvReleaseImage( &hsvImage );
	cvReleaseImage( &skinImage );
	cvReleaseImage( &temp );
	cvReleaseImage( &label );
	cvReleaseImage( &convexHullImage );
	//	EBhEj
	cvDestroyWindow( windowNameCapture );
	cvDestroyWindow( windowNameSkin );
	cvDestroyWindow( windowNameConvexHull );

	return 0;
}
